<?php

/**
 * remision_aprobada actions.
 *
 * @package    cobro_coactivo
 * @subpackage remision_aprobada
 * @author     Manuel Enrique Paredes Lopez
 * @version    SVN: $Id: actions.class.php 23810 2009-11-12 11:07:44Z Kris.Wallsmith $
 */
class remision_aprobadaActions extends sfQuery {
    /*
     * ------------VARIABLES PARA SERVICIOS DE CONSULTA - LIST
     */

    protected $table_names = array(
        'CBR_APROB_DENEG',
        'CBR_REMISION_TITULO',
        'CBR_PAR',
        'CBR_TITULO_MINERO_V',
        'CBR_ABOGADO_ULT_V',
        'CBR_PROCESO_COACTIVO'
    ); //tablas para construir el sql, por medio de joins
    protected $table_join_ids = array(
        'CBR_REMISION_TITULO' =>
        array(
            'id_remision_titulo' => 'CBR_APROB_DENEG'
        ),
        'CBR_PAR' =>
        array(
            'id_par' => 'CBR_REMISION_TITULO'
        ),
        'CBR_TITULO_MINERO_V,LEFT' =>
        array(
            'cod_titulo' => 'CBR_REMISION_TITULO'
        ),
        'CBR_ABOGADO_ULT_V,LEFT'=>
        array(
            'id_remision_titulo' => 'CBR_APROB_DENEG'
        ),
        'CBR_PROCESO_COACTIVO,LEFT'=>
        array(
            'id_remision_titulo' => 'CBR_REMISION_TITULO'
        )
    ); //si posee tablas para joins, identificar la relacion de los campos con las tablas
    protected $fields = array(
        'CBR_APROB_DENEG' =>
        array(
            'id_aprob_deneg' => 'id_aprob_deneg',
            'id_remision_titulo' => 'id_remision_titulo',
            'fecha' => 'fecha',
            'observaciones' => 'observaciones',
            'adjunto' => 'adjunto',
            'aprobado' => 'aprobado',
            'fecha_log' => 'fecha_log',
            'usuario_log' => 'usuario_log',
            'actual' => 'actual'
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'numero_remision' => 'numero_remision',
            'anho_remision' => 'anho_remision',
            'numero_correpondencia' => 'numero_correpondencia',
            'fecha_remision' => 'fecha_remision',
            'id_par' => 'id_par',
            'no_folios' => 'no_folios',
            'estado' => 'estado',
            'cod_titulo' => 'cod_titulo'
        ),
        'CBR_TITULO_MINERO_V' =>
        array(
            'mineral' => 'mineral',
            'id_debito' => 'id_debito',
            'id_mineral' => 'id_mineral'
        ),
        'CBR_PAR' =>
        array(
            'descripcion' => 'descripcion_par'
        ),
        'CBR_ABOGADO_ULT_V'=>
        array(
            'id_abogado'=>'id_abogado',
            'num_doc'=>'num_doc',
            'razon_soc'=>'abogado'
        ),
        'CBR_PROCESO_COACTIVO'=>
        array(
            'no_proceso'=>'no_proceso',
            'id_anhos'=>'id_anhos_proceso',
            'fecha'=>'fecha_proceso'
        )
    ); //por cada tabla especificar los campos del select
    protected $fields_orderBy = array(
        'anho_remision desc', 'numero_remision desc', 'actual desc', 'fecha desc', 'fecha_log desc'
    ); //campos para el ordenamiento de la consulta
    /*
     * OPCIONES DE FILTRO:
     *
     * LIKEALLPLUS- busqueda comparativa de la cadena dividida por los espacios en blanco en cualquier posición
     * LIKEALL - busqueda comparativa de la cadena en cualquier posición
     * LIKE - busqueda en la cadena que inicie por la variable de filtro
     *
     * rownum,start - rownum,end / estos campos para uso del Grid live GWT, numero fijo de filas de consulta
     */
    protected $table_field_conditions = array(
        'CBR_APROB_DENEG' =>
        array(
            'id_aprob_deneg,a' => array('!=' => array(-1)),
            'id_aprob_deneg,b' => array('=' => array('id_aprob_deneg')),
            'id_remision_titulo' => array('=' => array('id_remision_titulo')),
            'aprobado' => array('=' => array('aprobado')),
            'actual' => array('=' => array('actual')),
            'fecha' => array('BETWEENFECHA' => array('fecha_ini', 'fecha_fin')),
            'rownum,start' => array('>' => array('_startRow')),
            'rownum,end' => array('<=' => array('_endRow'))
        ),
        'CBR_REMISION_TITULO' =>
        array(
            'id_par' => array('=' => array('id_par')),
            'numero_remision' => array('=' => array('numero_remision')),
            'anho_remision' => array('=' => array('anho_remision')),
            'numero_correpondencia' => array('=' => array('numero_correpondencia')),
            'estado' => array('=' => array('estado')),
            'cod_titulo' => array('=' => array('cod_titulo'))
        ),
        'CBR_ABOGADO_ULT_V'=>
        array(
            'id_abogado' => array('=' => array('id_abogado')),
            'num_doc' => array('IN' => array('num_doc'))
        )
    ); //por cada tabla se dan los campos, opcion de filtro y variable que entra para los posibles filtros
    protected $table_field_or_conditions = array(
    ); // filtros de condicion or
    /*
     * Variable manejo de log
     */
    //true - consulta de menu administracion
    protected $is_admin = true;
    //si es servicio para filtro agregar campo
//    protected $filtro = 'Perfiles';
    //true - la tabla principal de busqueda no es una vista
    protected $is_filtro = true;
    /*
     * ------------VARIABLES PARA SERVICIOS CRUD
     */
    protected $id_name = 'id_aprob_deneg'; //identificador de la tabla
    protected $id_names = array('id_aprob_deneg'); //llave primaria
    protected $field_names = array('id_remision_titulo', 'fecha', 'observaciones', 'adjunto',
        'aprobado', 'usuario_log'); //campos de la tabla, sin la llave primaria
    protected $table_name = 'CBR_APROB_DENEG'; //tabla en la cual se aplican los cambios 
    /*
     * Manejo de registro log
     */
    protected $id_unico = 'id_aprob_deneg'; //identificador unico de la tabla

    protected function postprocessRequest($Action, \sfWebRequest $request, $list_data_post) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a postprocessRequest - " . $list_data_post);
        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {

        }

        return $request;
    }

    protected function preprocessRequest($Action, \sfWebRequest $request) {
        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a preprocessRequest");

        /*
         * Procesar Request
         */
        //accion add
        if ($Action == "ADD") {

            
        }

        //accion update
        if ($Action == "UPDATE") {
            
        }

        //accion remove
        if ($Action == "REMOVE") {

        
        }

        return $request;
    }

    protected function validateAdd(\sfWebRequest $request) {

        /*
         * Se instancia la clase del manejo del log
         */
        $logger = sfContext::getInstance()->getLogger();
        $logger->info("Entro a validateAdd");

        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */
        //Mira si el estado actual es el que van a registrar - 20200225
        //sentencia sql


        return $errors;
    }

    protected function validateRemove(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

    protected function validateUpdate(\sfWebRequest $request) {
        //valor por defecto
        $errors = null;

        /*
         *  Validar la operación, ya sea por SQL
         */

        /*
         *  Generar errores en $errors
         */

        return $errors;
    }

}
